#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_SURFACE_SPEC_VERSION")]
pub const KHR_SURFACE_SPEC_VERSION: u32 = 25;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_SURFACE_EXTENSION_NAME")]
pub const KHR_SURFACE_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_surface");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_DESTROY_SURFACE_KHR: *const std::os::raw::c_char = crate::cstr!("vkDestroySurfaceKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_SURFACE_SUPPORT_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceSurfaceSupportKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_SURFACE_CAPABILITIES_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceSurfaceCapabilitiesKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_SURFACE_FORMATS_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceSurfaceFormatsKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_SURFACE_PRESENT_MODES_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceSurfacePresentModesKHR");
crate::non_dispatchable_handle!(SurfaceKHR, SURFACE_KHR, "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceKHR.html)) · Non-dispatchable Handle <br/> VkSurfaceKHR - Opaque handle to a surface object\n[](#_c_specification)C Specification\n----------\n\nNative platform surface or window objects are abstracted by surface objects,\nwhich are represented by [`crate::vk::SurfaceKHR`] handles:\n\n```\n// Provided by VK_KHR_surface\nVK_DEFINE_NON_DISPATCHABLE_HANDLE(VkSurfaceKHR)\n```\n[](#_description)Description\n----------\n\nThe `VK_KHR_surface` extension declares the [`crate::vk::SurfaceKHR`] object, and\nprovides a function for destroying [`crate::vk::SurfaceKHR`] objects.\nSeparate platform-specific extensions each provide a function for creating a[`crate::vk::SurfaceKHR`] object for the respective platform.\nFrom the application’s perspective this is an opaque handle, just like the\nhandles of other Vulkan objects.\n\n|   |Note<br/><br/>On certain platforms, the Vulkan loader and ICDs **may** have conventions that<br/>treat the handle as a pointer to a structure containing the<br/>platform-specific information about the surface.<br/>This will be described in the documentation for the loader-ICD interface,<br/>and in the `vk_icd.h` header file of the LoaderAndTools source-code<br/>repository.<br/>This does not affect the loader-layer interface; layers **may** wrap[`crate::vk::SurfaceKHR`] objects.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDeviceSurfaceInfo2KHR`], [`crate::vk::SwapchainCreateInfoKHR`], [`crate::vk::InstanceLoader::create_android_surface_khr`], [`crate::vk::InstanceLoader::create_direct_fb_surface_ext`], [`crate::vk::InstanceLoader::create_display_plane_surface_khr`], [`crate::vk::InstanceLoader::create_headless_surface_ext`], [`crate::vk::InstanceLoader::create_ios_surface_mvk`], [`crate::vk::InstanceLoader::create_image_pipe_surface_fuchsia`], [`crate::vk::InstanceLoader::create_mac_os_surface_mvk`], [`crate::vk::InstanceLoader::create_metal_surface_ext`], [`crate::vk::InstanceLoader::create_screen_surface_qnx`], [`crate::vk::InstanceLoader::create_stream_descriptor_surface_ggp`], [`crate::vk::InstanceLoader::create_vi_surface_nn`], [`crate::vk::InstanceLoader::create_wayland_surface_khr`], [`crate::vk::InstanceLoader::create_win32_surface_khr`], [`crate::vk::InstanceLoader::create_xcb_surface_khr`], [`crate::vk::InstanceLoader::create_xlib_surface_khr`], [`crate::vk::InstanceLoader::destroy_surface_khr`], [`crate::vk::DeviceLoader::get_device_group_surface_present_modes_khr`], [`crate::vk::DeviceLoader::get_physical_device_present_rectangles_khr`], [`crate::vk::InstanceLoader::get_physical_device_surface_capabilities2_ext`], [`crate::vk::InstanceLoader::get_physical_device_surface_capabilities_khr`], [`crate::vk::InstanceLoader::get_physical_device_surface_formats_khr`], [`crate::vk::InstanceLoader::get_physical_device_surface_present_modes_khr`], [`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`]\n", "VkSurfaceKHR");
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::vk1_0::Result {
    pub const ERROR_SURFACE_LOST_KHR: Self = Self(-1000000000);
    pub const ERROR_NATIVE_WINDOW_IN_USE_KHR: Self = Self(-1000000001);
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::vk1_0::ObjectType {
    pub const SURFACE_KHR: Self = Self(1000000000);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkColorSpaceKHR.html)) · Enum <br/> VkColorSpaceKHR - supported color space of the presentation engine\n[](#_c_specification)C Specification\n----------\n\nPossible values of [`crate::vk::SurfaceFormatKHR::color_space`], specifying\nsupported color spaces of a presentation engine, are:\n\n```\n// Provided by VK_KHR_surface\ntypedef enum VkColorSpaceKHR {\n    VK_COLOR_SPACE_SRGB_NONLINEAR_KHR = 0,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_DISPLAY_P3_NONLINEAR_EXT = 1000104001,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_EXTENDED_SRGB_LINEAR_EXT = 1000104002,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_DISPLAY_P3_LINEAR_EXT = 1000104003,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_DCI_P3_NONLINEAR_EXT = 1000104004,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_BT709_LINEAR_EXT = 1000104005,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_BT709_NONLINEAR_EXT = 1000104006,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_BT2020_LINEAR_EXT = 1000104007,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_HDR10_ST2084_EXT = 1000104008,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_DOLBYVISION_EXT = 1000104009,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_HDR10_HLG_EXT = 1000104010,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_ADOBERGB_LINEAR_EXT = 1000104011,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_ADOBERGB_NONLINEAR_EXT = 1000104012,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_PASS_THROUGH_EXT = 1000104013,\n  // Provided by VK_EXT_swapchain_colorspace\n    VK_COLOR_SPACE_EXTENDED_SRGB_NONLINEAR_EXT = 1000104014,\n  // Provided by VK_AMD_display_native_hdr\n    VK_COLOR_SPACE_DISPLAY_NATIVE_AMD = 1000213000,\n    VK_COLORSPACE_SRGB_NONLINEAR_KHR = VK_COLOR_SPACE_SRGB_NONLINEAR_KHR,\n    VK_COLOR_SPACE_DCI_P3_LINEAR_EXT = VK_COLOR_SPACE_DISPLAY_P3_LINEAR_EXT,\n} VkColorSpaceKHR;\n```\n[](#_description)Description\n----------\n\n* [`Self::SRGB_NONLINEAR_KHR`] specifies support for the sRGB\n  color space.\n\n* [`Self::DISPLAY_P3_NONLINEAR_EXT`] specifies support for the\n  Display-P3 color space to be displayed using an sRGB-like EOTF (defined\n  below).\n\n* [`Self::EXTENDED_SRGB_LINEAR_EXT`] specifies support for the\n  extended sRGB color space to be displayed using a linear EOTF.\n\n* [`Self::EXTENDED_SRGB_NONLINEAR_EXT`] specifies support for\n  the extended sRGB color space to be displayed using an sRGB EOTF.\n\n* [`Self::DISPLAY_P3_LINEAR_EXT`] specifies support for the\n  Display-P3 color space to be displayed using a linear EOTF.\n\n* [`Self::DCI_P3_NONLINEAR_EXT`] specifies support for the\n  DCI-P3 color space to be displayed using the DCI-P3 EOTF.\n  Note that values in such an image are interpreted as XYZ encoded color\n  data by the presentation engine.\n\n* [`Self::BT709_LINEAR_EXT`] specifies support for the BT709\n  color space to be displayed using a linear EOTF.\n\n* [`Self::BT709_NONLINEAR_EXT`] specifies support for the BT709\n  color space to be displayed using the SMPTE 170M EOTF.\n\n* [`Self::BT2020_LINEAR_EXT`] specifies support for the BT2020\n  color space to be displayed using a linear EOTF.\n\n* [`Self::HDR10_ST2084_EXT`] specifies support for the HDR10\n  (BT2020 color) space to be displayed using the SMPTE ST2084 Perceptual\n  Quantizer (PQ) EOTF.\n\n* [`Self::DOLBYVISION_EXT`] specifies support for the Dolby\n  Vision (BT2020 color space), proprietary encoding, to be displayed using\n  the SMPTE ST2084 EOTF.\n\n* [`Self::HDR10_HLG_EXT`] specifies support for the HDR10\n  (BT2020 color space) to be displayed using the Hybrid Log Gamma (HLG)\n  EOTF.\n\n* [`Self::ADOBERGB_LINEAR_EXT`] specifies support for the\n  AdobeRGB color space to be displayed using a linear EOTF.\n\n* [`Self::ADOBERGB_NONLINEAR_EXT`] specifies support for the\n  AdobeRGB color space to be displayed using the Gamma 2.2 EOTF.\n\n* [`Self::PASS_THROUGH_EXT`] specifies that color components\n  are used “as is”.\n  This is intended to allow applications to supply data for color spaces\n  not described here.\n\n* [`Self::DISPLAY_NATIVE_AMD`] specifies support for the\n  display’s native color space.\n  This matches the color space expectations of AMD’s FreeSync2 standard,\n  for displays supporting it.\n\n|   |Note<br/><br/>In the initial release of the `VK_KHR_surface` and [VK_KHR_swapchain](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VK_KHR_swapchain.html)extensions, the token [`Self::COLORSPACE_SRGB_NONLINEAR_KHR`] was used.<br/>Starting in the 2016-05-13 updates to the extension branches, matching<br/>release 1.0.13 of the core API specification,[`Self::SRGB_NONLINEAR_KHR`] is used instead for consistency with<br/>Vulkan naming rules.<br/>The older enum is still available for backwards compatibility.|\n|---|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>In older versions of this extension[`Self::DISPLAY_P3_LINEAR_EXT`] was misnamed[`Self::DCI_P3_LINEAR_EXT`].<br/>This has been updated to indicate that it uses RGB color encoding, not XYZ.<br/>The old name is deprecated but is maintained for backwards compatibility.|\n|---|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nThe color components of non-linear color space swap chain images **must** have\nhad the appropriate transfer function applied.\nThe color space selected for the swap chain image will not affect the\nprocessing of data written into the image by the implementation.\nVulkan requires that all implementations support the sRGB transfer function\nby use of an SRGB pixel format.\nOther transfer functions, such as SMPTE 170M or SMPTE2084, **can** be performed\nby the application shader.\nThis extension defines enums for [`crate::vk::ColorSpaceKHR`] that correspond to\nthe following color spaces:\n\n|    Name     |Red Primary |Green Primary|Blue Primary|    White-point     |Transfer function|\n|-------------|------------|-------------|------------|--------------------|-----------------|\n|   DCI-P3    |1.000, 0.000|0.000, 1.000 |0.000, 0.000|   0.3333, 0.3333   |     DCI P3      |\n| Display-P3  |0.680, 0.320|0.265, 0.690 |0.150, 0.060|0.3127, 0.3290 (D65)|   Display-P3    |\n|    BT709    |0.640, 0.330|0.300, 0.600 |0.150, 0.060|0.3127, 0.3290 (D65)|ITU (SMPTE 170M) |\n|    sRGB     |0.640, 0.330|0.300, 0.600 |0.150, 0.060|0.3127, 0.3290 (D65)|      sRGB       |\n|extended sRGB|0.640, 0.330|0.300, 0.600 |0.150, 0.060|0.3127, 0.3290 (D65)|  extended sRGB  |\n|HDR10\\_ST2084|0.708, 0.292|0.170, 0.797 |0.131, 0.046|0.3127, 0.3290 (D65)|    ST2084 PQ    |\n| DOLBYVISION |0.708, 0.292|0.170, 0.797 |0.131, 0.046|0.3127, 0.3290 (D65)|    ST2084 PQ    |\n| HDR10\\_HLG  |0.708, 0.292|0.170, 0.797 |0.131, 0.046|0.3127, 0.3290 (D65)|       HLG       |\n|  AdobeRGB   |0.640, 0.330|0.210, 0.710 |0.150, 0.060|0.3127, 0.3290 (D65)|    AdobeRGB     |\n\nThe transfer functions are described in the “Transfer Functions” chapter\nof the [Khronos Data Format Specification](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#data-format).\n\nExcept Display-P3 OETF, which is:\n\nE\u{200b}={1.055×L2.41\u{200b}−0.05512.92×L\u{200b}for\u{a0}0.0030186≤L≤1for\u{a0}0≤L\\<0.0030186\u{200b}\u{200b}\n\nwhere L is the linear value of a color channel and E is the\nencoded value (as stored in the image in memory).\n\n|   |Note<br/><br/>For most uses, the sRGB OETF is equivalent.|\n|---|---------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SurfaceFormatKHR`], [`crate::vk::SwapchainCreateInfoKHR`]\n"]
#[doc(alias = "VkColorSpaceKHR")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct ColorSpaceKHR(pub i32);
impl std::fmt::Debug for ColorSpaceKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            &Self::SRGB_NONLINEAR_KHR => "SRGB_NONLINEAR_KHR",
            &Self::DISPLAY_P3_NONLINEAR_EXT => "DISPLAY_P3_NONLINEAR_EXT",
            &Self::EXTENDED_SRGB_LINEAR_EXT => "EXTENDED_SRGB_LINEAR_EXT",
            &Self::DISPLAY_P3_LINEAR_EXT => "DISPLAY_P3_LINEAR_EXT",
            &Self::DCI_P3_NONLINEAR_EXT => "DCI_P3_NONLINEAR_EXT",
            &Self::BT709_LINEAR_EXT => "BT709_LINEAR_EXT",
            &Self::BT709_NONLINEAR_EXT => "BT709_NONLINEAR_EXT",
            &Self::BT2020_LINEAR_EXT => "BT2020_LINEAR_EXT",
            &Self::HDR10_ST2084_EXT => "HDR10_ST2084_EXT",
            &Self::DOLBYVISION_EXT => "DOLBYVISION_EXT",
            &Self::HDR10_HLG_EXT => "HDR10_HLG_EXT",
            &Self::ADOBERGB_LINEAR_EXT => "ADOBERGB_LINEAR_EXT",
            &Self::ADOBERGB_NONLINEAR_EXT => "ADOBERGB_NONLINEAR_EXT",
            &Self::PASS_THROUGH_EXT => "PASS_THROUGH_EXT",
            &Self::EXTENDED_SRGB_NONLINEAR_EXT => "EXTENDED_SRGB_NONLINEAR_EXT",
            &Self::DISPLAY_NATIVE_AMD => "DISPLAY_NATIVE_AMD",
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::extensions::khr_surface::ColorSpaceKHR {
    pub const SRGB_NONLINEAR_KHR: Self = Self(0);
    pub const COLORSPACE_SRGB_NONLINEAR_KHR: Self = Self::SRGB_NONLINEAR_KHR;
}
bitflags::bitflags! { # [doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagsKHR.html)) · Bitmask of [`CompositeAlphaFlagBitsKHR`] <br/> VkCompositeAlphaFlagsKHR - Bitmask of VkCompositeAlphaFlagBitsKHR\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_KHR_surface\ntypedef VkFlags VkCompositeAlphaFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::CompositeAlphaFlagBitsKHR`] is a bitmask type for setting a mask of zero\nor more [VkCompositeAlphaFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html).\n[](#_see_also)See Also\n----------\n\n[VkCompositeAlphaFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html), [`crate::vk::SurfaceCapabilities2EXT`], [`crate::vk::SurfaceCapabilitiesKHR`]\n"] # [doc (alias = "VkCompositeAlphaFlagsKHR")] # [derive (Default)] # [repr (transparent)] pub struct CompositeAlphaFlagsKHR : u32 { const OPAQUE_KHR = CompositeAlphaFlagBitsKHR :: OPAQUE_KHR . 0 ; const PRE_MULTIPLIED_KHR = CompositeAlphaFlagBitsKHR :: PRE_MULTIPLIED_KHR . 0 ; const POST_MULTIPLIED_KHR = CompositeAlphaFlagBitsKHR :: POST_MULTIPLIED_KHR . 0 ; const INHERIT_KHR = CompositeAlphaFlagBitsKHR :: INHERIT_KHR . 0 ; } }
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html)) · Bits enum of [`CompositeAlphaFlagsKHR`] <br/> VkCompositeAlphaFlagBitsKHR - alpha compositing modes supported on a device\n[](#_c_specification)C Specification\n----------\n\nThe `supportedCompositeAlpha` member is of type[VkCompositeAlphaFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html), which contains the following values:\n\n```\n// Provided by VK_KHR_surface\ntypedef enum VkCompositeAlphaFlagBitsKHR {\n    VK_COMPOSITE_ALPHA_OPAQUE_BIT_KHR = 0x00000001,\n    VK_COMPOSITE_ALPHA_PRE_MULTIPLIED_BIT_KHR = 0x00000002,\n    VK_COMPOSITE_ALPHA_POST_MULTIPLIED_BIT_KHR = 0x00000004,\n    VK_COMPOSITE_ALPHA_INHERIT_BIT_KHR = 0x00000008,\n} VkCompositeAlphaFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\nThese values are described as follows:\n\n* [`Self::OPAQUE_KHR`]: The alpha channel, if it\n  exists, of the images is ignored in the compositing process.\n  Instead, the image is treated as if it has a constant alpha of 1.0.\n\n* [`Self::PRE_MULTIPLIED_KHR`]: The alpha channel, if\n  it exists, of the images is respected in the compositing process.\n  The non-alpha channels of the image are expected to already be\n  multiplied by the alpha channel by the application.\n\n* [`Self::POST_MULTIPLIED_KHR`]: The alpha channel, if\n  it exists, of the images is respected in the compositing process.\n  The non-alpha channels of the image are not expected to already be\n  multiplied by the alpha channel by the application; instead, the\n  compositor will multiply the non-alpha channels of the image by the\n  alpha channel during compositing.\n\n* [`Self::INHERIT_KHR`]: The way in which the\n  presentation engine treats the alpha channel in the images is unknown to\n  the Vulkan API.\n  Instead, the application is responsible for setting the composite alpha\n  blending mode using native window system commands.\n  If the application does not set the blending mode using native window\n  system commands, then a platform-specific default will be used.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CompositeAlphaFlagBitsKHR`], [`crate::vk::SwapchainCreateInfoKHR`]\n"]
#[doc(alias = "VkCompositeAlphaFlagBitsKHR")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct CompositeAlphaFlagBitsKHR(pub u32);
impl CompositeAlphaFlagBitsKHR {
    #[inline]
    #[doc = "Converts this enum variant to the corresponding bitmask"]
    pub const fn bitmask(&self) -> CompositeAlphaFlagsKHR {
        CompositeAlphaFlagsKHR::from_bits_truncate(self.0)
    }
}
impl std::fmt::Debug for CompositeAlphaFlagBitsKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            &Self::OPAQUE_KHR => "OPAQUE_KHR",
            &Self::PRE_MULTIPLIED_KHR => "PRE_MULTIPLIED_KHR",
            &Self::POST_MULTIPLIED_KHR => "POST_MULTIPLIED_KHR",
            &Self::INHERIT_KHR => "INHERIT_KHR",
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::extensions::khr_surface::CompositeAlphaFlagBitsKHR {
    pub const OPAQUE_KHR: Self = Self(1);
    pub const PRE_MULTIPLIED_KHR: Self = Self(2);
    pub const POST_MULTIPLIED_KHR: Self = Self(4);
    pub const INHERIT_KHR: Self = Self(8);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPresentModeKHR.html)) · Enum <br/> VkPresentModeKHR - presentation mode supported for a surface\n[](#_c_specification)C Specification\n----------\n\nPossible values of elements of the[`crate::vk::InstanceLoader::get_physical_device_surface_present_modes_khr::p_present_modes`] array,\nindicating the supported presentation modes for a surface, are:\n\n```\n// Provided by VK_KHR_surface\ntypedef enum VkPresentModeKHR {\n    VK_PRESENT_MODE_IMMEDIATE_KHR = 0,\n    VK_PRESENT_MODE_MAILBOX_KHR = 1,\n    VK_PRESENT_MODE_FIFO_KHR = 2,\n    VK_PRESENT_MODE_FIFO_RELAXED_KHR = 3,\n  // Provided by VK_KHR_shared_presentable_image\n    VK_PRESENT_MODE_SHARED_DEMAND_REFRESH_KHR = 1000111000,\n  // Provided by VK_KHR_shared_presentable_image\n    VK_PRESENT_MODE_SHARED_CONTINUOUS_REFRESH_KHR = 1000111001,\n} VkPresentModeKHR;\n```\n[](#_description)Description\n----------\n\n* [`Self::IMMEDIATE_KHR`] specifies that the presentation\n  engine does not wait for a vertical blanking period to update the\n  current image, meaning this mode **may** result in visible tearing.\n  No internal queuing of presentation requests is needed, as the requests\n  are applied immediately.\n\n* [`Self::MAILBOX_KHR`] specifies that the presentation engine\n  waits for the next vertical blanking period to update the current image.\n  Tearing **cannot** be observed.\n  An internal single-entry queue is used to hold pending presentation\n  requests.\n  If the queue is full when a new presentation request is received, the\n  new request replaces the existing entry, and any images associated with\n  the prior entry become available for re-use by the application.\n  One request is removed from the queue and processed during each vertical\n  blanking period in which the queue is non-empty.\n\n* [`Self::FIFO_KHR`] specifies that the presentation engine\n  waits for the next vertical blanking period to update the current image.\n  Tearing **cannot** be observed.\n  An internal queue is used to hold pending presentation requests.\n  New requests are appended to the end of the queue, and one request is\n  removed from the beginning of the queue and processed during each\n  vertical blanking period in which the queue is non-empty.\n  This is the only value of `presentMode` that is **required** to be\n  supported.\n\n* [`Self::FIFO_RELAXED_KHR`] specifies that the presentation\n  engine generally waits for the next vertical blanking period to update\n  the current image.\n  If a vertical blanking period has already passed since the last update\n  of the current image then the presentation engine does not wait for\n  another vertical blanking period for the update, meaning this mode **may**result in visible tearing in this case.\n  This mode is useful for reducing visual stutter with an application that\n  will mostly present a new image before the next vertical blanking\n  period, but may occasionally be late, and present a new image just after\n  the next vertical blanking period.\n  An internal queue is used to hold pending presentation requests.\n  New requests are appended to the end of the queue, and one request is\n  removed from the beginning of the queue and processed during or after\n  each vertical blanking period in which the queue is non-empty.\n\n* [`Self::SHARED_DEMAND_REFRESH_KHR`] specifies that the\n  presentation engine and application have concurrent access to a single\n  image, which is referred to as a *shared presentable image*.\n  The presentation engine is only required to update the current image\n  after a new presentation request is received.\n  Therefore the application **must** make a presentation request whenever an\n  update is required.\n  However, the presentation engine **may** update the current image at any\n  point, meaning this mode **may** result in visible tearing.\n\n* [`Self::SHARED_CONTINUOUS_REFRESH_KHR`] specifies that the\n  presentation engine and application have concurrent access to a single\n  image, which is referred to as a *shared presentable image*.\n  The presentation engine periodically updates the current image on its\n  regular refresh cycle.\n  The application is only required to make one initial presentation\n  request, after which the presentation engine **must** update the current\n  image without any need for further presentation requests.\n  The application **can** indicate the image contents have been updated by\n  making a presentation request, but this does not guarantee the timing of\n  when it will be updated.\n  This mode **may** result in visible tearing if rendering to the image is\n  not timed correctly.\n\nThe supported [VkImageUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageUsageFlagBits.html) of the presentable images of a\nswapchain created for a surface **may** differ depending on the presentation\nmode, and can be determined as per the table below:\n\n|               Presentation mode               |                                                   Image usage flags                                                   |\n|-----------------------------------------------|-----------------------------------------------------------------------------------------------------------------------|\n|        [`Self::IMMEDIATE_KHR`]        |                   [`crate::vk::SurfaceCapabilitiesKHR::supported_usage_flags`]                    |\n|         [`Self::MAILBOX_KHR`]         |                   [`crate::vk::SurfaceCapabilitiesKHR::supported_usage_flags`]                    |\n|          [`Self::FIFO_KHR`]           |                   [`crate::vk::SurfaceCapabilitiesKHR::supported_usage_flags`]                    |\n|      [`Self::FIFO_RELAXED_KHR`]       |                   [`crate::vk::SurfaceCapabilitiesKHR::supported_usage_flags`]                    |\n|  [`Self::SHARED_DEMAND_REFRESH_KHR`]  |[`crate::vk::SharedPresentSurfaceCapabilitiesKHR::shared_present_supported_usage_flags`]|\n|[`Self::SHARED_CONTINUOUS_REFRESH_KHR`]|[`crate::vk::SharedPresentSurfaceCapabilitiesKHR::shared_present_supported_usage_flags`]|\n\n|   |Note<br/><br/>For reference, the mode indicated by [`Self::FIFO_KHR`] is<br/>equivalent to the behavior of {wgl|glX|egl}SwapBuffers with a swap interval<br/>of 1, while the mode indicated by [`Self::FIFO_RELAXED_KHR`] is<br/>equivalent to the behavior of {wgl|glX}SwapBuffers with a swap interval of<br/>-1 (from the {WGL|GLX}\\_EXT\\_swap\\_control\\_tear extensions).|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SwapchainCreateInfoKHR`], [`crate::vk::DeviceLoader::get_physical_device_surface_present_modes2_ext`], [`crate::vk::InstanceLoader::get_physical_device_surface_present_modes_khr`]\n"]
#[doc(alias = "VkPresentModeKHR")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct PresentModeKHR(pub i32);
impl std::fmt::Debug for PresentModeKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            &Self::IMMEDIATE_KHR => "IMMEDIATE_KHR",
            &Self::MAILBOX_KHR => "MAILBOX_KHR",
            &Self::FIFO_KHR => "FIFO_KHR",
            &Self::FIFO_RELAXED_KHR => "FIFO_RELAXED_KHR",
            &Self::SHARED_DEMAND_REFRESH_KHR => "SHARED_DEMAND_REFRESH_KHR",
            &Self::SHARED_CONTINUOUS_REFRESH_KHR => "SHARED_CONTINUOUS_REFRESH_KHR",
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::extensions::khr_surface::PresentModeKHR {
    pub const IMMEDIATE_KHR: Self = Self(0);
    pub const MAILBOX_KHR: Self = Self(1);
    pub const FIFO_KHR: Self = Self(2);
    pub const FIFO_RELAXED_KHR: Self = Self(3);
}
bitflags::bitflags! { # [doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagsKHR.html)) · Bitmask of [`SurfaceTransformFlagBitsKHR`] <br/> VkSurfaceTransformFlagsKHR - Bitmask of VkSurfaceTransformFlagBitsKHR\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_KHR_display\ntypedef VkFlags VkSurfaceTransformFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::SurfaceTransformFlagBitsKHR`] is a bitmask type for setting a mask of\nzero or more [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html).\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DisplayPropertiesKHR`], [`crate::vk::SurfaceCapabilities2EXT`], [`crate::vk::SurfaceCapabilitiesKHR`], [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html)\n"] # [doc (alias = "VkSurfaceTransformFlagsKHR")] # [derive (Default)] # [repr (transparent)] pub struct SurfaceTransformFlagsKHR : u32 { const IDENTITY_KHR = SurfaceTransformFlagBitsKHR :: IDENTITY_KHR . 0 ; const ROTATE_90_KHR = SurfaceTransformFlagBitsKHR :: ROTATE_90_KHR . 0 ; const ROTATE_180_KHR = SurfaceTransformFlagBitsKHR :: ROTATE_180_KHR . 0 ; const ROTATE_270_KHR = SurfaceTransformFlagBitsKHR :: ROTATE_270_KHR . 0 ; const HORIZONTAL_MIRROR_KHR = SurfaceTransformFlagBitsKHR :: HORIZONTAL_MIRROR_KHR . 0 ; const HORIZONTAL_MIRROR_ROTATE_90_KHR = SurfaceTransformFlagBitsKHR :: HORIZONTAL_MIRROR_ROTATE_90_KHR . 0 ; const HORIZONTAL_MIRROR_ROTATE_180_KHR = SurfaceTransformFlagBitsKHR :: HORIZONTAL_MIRROR_ROTATE_180_KHR . 0 ; const HORIZONTAL_MIRROR_ROTATE_270_KHR = SurfaceTransformFlagBitsKHR :: HORIZONTAL_MIRROR_ROTATE_270_KHR . 0 ; const INHERIT_KHR = SurfaceTransformFlagBitsKHR :: INHERIT_KHR . 0 ; } }
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html)) · Bits enum of [`SurfaceTransformFlagsKHR`] <br/> VkSurfaceTransformFlagBitsKHR - presentation transforms supported on a device\n[](#_c_specification)C Specification\n----------\n\nBits which **may** be set in[`crate::vk::SurfaceCapabilitiesKHR::supported_transforms`] indicating the\npresentation transforms supported for the surface on the specified device,\nand possible values of[`crate::vk::SurfaceCapabilitiesKHR::current_transform`] indicating the\nsurface’s current transform relative to the presentation engine’s natural\norientation, are:\n\n```\n// Provided by VK_KHR_surface\ntypedef enum VkSurfaceTransformFlagBitsKHR {\n    VK_SURFACE_TRANSFORM_IDENTITY_BIT_KHR = 0x00000001,\n    VK_SURFACE_TRANSFORM_ROTATE_90_BIT_KHR = 0x00000002,\n    VK_SURFACE_TRANSFORM_ROTATE_180_BIT_KHR = 0x00000004,\n    VK_SURFACE_TRANSFORM_ROTATE_270_BIT_KHR = 0x00000008,\n    VK_SURFACE_TRANSFORM_HORIZONTAL_MIRROR_BIT_KHR = 0x00000010,\n    VK_SURFACE_TRANSFORM_HORIZONTAL_MIRROR_ROTATE_90_BIT_KHR = 0x00000020,\n    VK_SURFACE_TRANSFORM_HORIZONTAL_MIRROR_ROTATE_180_BIT_KHR = 0x00000040,\n    VK_SURFACE_TRANSFORM_HORIZONTAL_MIRROR_ROTATE_270_BIT_KHR = 0x00000080,\n    VK_SURFACE_TRANSFORM_INHERIT_BIT_KHR = 0x00000100,\n} VkSurfaceTransformFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`Self::IDENTITY_KHR`] specifies that image content\n  is presented without being transformed.\n\n* [`Self::ROTATE_90_KHR`] specifies that image\n  content is rotated 90 degrees clockwise.\n\n* [`Self::ROTATE_180_KHR`] specifies that image\n  content is rotated 180 degrees clockwise.\n\n* [`Self::ROTATE_270_KHR`] specifies that image\n  content is rotated 270 degrees clockwise.\n\n* [`Self::HORIZONTAL_MIRROR_KHR`] specifies that\n  image content is mirrored horizontally.\n\n* [`Self::HORIZONTAL_MIRROR_ROTATE_90_KHR`] specifies\n  that image content is mirrored horizontally, then rotated 90 degrees\n  clockwise.\n\n* [`Self::HORIZONTAL_MIRROR_ROTATE_180_KHR`]specifies that image content is mirrored horizontally, then rotated 180\n  degrees clockwise.\n\n* [`Self::HORIZONTAL_MIRROR_ROTATE_270_KHR`]specifies that image content is mirrored horizontally, then rotated 270\n  degrees clockwise.\n\n* [`Self::INHERIT_KHR`] specifies that the\n  presentation transform is not specified, and is instead determined by\n  platform-specific considerations and mechanisms outside Vulkan.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBufferInheritanceRenderPassTransformInfoQCOM`], [`crate::vk::CopyCommandTransformInfoQCOM`], [`crate::vk::DisplaySurfaceCreateInfoKHR`], [`crate::vk::RenderPassTransformBeginInfoQCOM`], [`crate::vk::SurfaceCapabilities2EXT`], [`crate::vk::SurfaceCapabilitiesKHR`], [`crate::vk::SurfaceTransformFlagBitsKHR`], [`crate::vk::SwapchainCreateInfoKHR`]\n"]
#[doc(alias = "VkSurfaceTransformFlagBitsKHR")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct SurfaceTransformFlagBitsKHR(pub u32);
impl SurfaceTransformFlagBitsKHR {
    #[inline]
    #[doc = "Converts this enum variant to the corresponding bitmask"]
    pub const fn bitmask(&self) -> SurfaceTransformFlagsKHR {
        SurfaceTransformFlagsKHR::from_bits_truncate(self.0)
    }
}
impl std::fmt::Debug for SurfaceTransformFlagBitsKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            &Self::IDENTITY_KHR => "IDENTITY_KHR",
            &Self::ROTATE_90_KHR => "ROTATE_90_KHR",
            &Self::ROTATE_180_KHR => "ROTATE_180_KHR",
            &Self::ROTATE_270_KHR => "ROTATE_270_KHR",
            &Self::HORIZONTAL_MIRROR_KHR => "HORIZONTAL_MIRROR_KHR",
            &Self::HORIZONTAL_MIRROR_ROTATE_90_KHR => "HORIZONTAL_MIRROR_ROTATE_90_KHR",
            &Self::HORIZONTAL_MIRROR_ROTATE_180_KHR => "HORIZONTAL_MIRROR_ROTATE_180_KHR",
            &Self::HORIZONTAL_MIRROR_ROTATE_270_KHR => "HORIZONTAL_MIRROR_ROTATE_270_KHR",
            &Self::INHERIT_KHR => "INHERIT_KHR",
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::extensions::khr_surface::SurfaceTransformFlagBitsKHR {
    pub const IDENTITY_KHR: Self = Self(1);
    pub const ROTATE_90_KHR: Self = Self(2);
    pub const ROTATE_180_KHR: Self = Self(4);
    pub const ROTATE_270_KHR: Self = Self(8);
    pub const HORIZONTAL_MIRROR_KHR: Self = Self(16);
    pub const HORIZONTAL_MIRROR_ROTATE_90_KHR: Self = Self(32);
    pub const HORIZONTAL_MIRROR_ROTATE_180_KHR: Self = Self(64);
    pub const HORIZONTAL_MIRROR_ROTATE_270_KHR: Self = Self(128);
    pub const INHERIT_KHR: Self = Self(256);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroySurfaceKHR.html)) · Function <br/> vkDestroySurfaceKHR - Destroy a VkSurfaceKHR object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a [`crate::vk::SurfaceKHR`] object, call:\n\n```\n// Provided by VK_KHR_surface\nvoid vkDestroySurfaceKHR(\n    VkInstance                                  instance,\n    VkSurfaceKHR                                surface,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::instance`] is the instance used to create the surface.\n\n* [`Self::surface`] is the surface to destroy.\n\n* [`Self::p_allocator`] is the allocator used for host memory allocated for the\n  surface object when there is no more specific allocator available (see[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation)).\n[](#_description)Description\n----------\n\nDestroying a [`crate::vk::SurfaceKHR`] merely severs the connection between Vulkan\nand the native surface, and does not imply destroying the native surface,\nclosing a window, or similar behavior.\n\nValid Usage\n\n* []() VUID-vkDestroySurfaceKHR-surface-01266  \n   All [`crate::vk::SwapchainKHR`] objects created for [`Self::surface`] **must** have\n  been destroyed prior to destroying [`Self::surface`]\n\n* []() VUID-vkDestroySurfaceKHR-surface-01267  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::surface`] was\n  created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroySurfaceKHR-surface-01268  \n   If no [`crate::vk::AllocationCallbacks`] were provided when [`Self::surface`] was\n  created, [`Self::p_allocator`] **must** be `NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroySurfaceKHR-instance-parameter  \n  [`Self::instance`] **must** be a valid [`crate::vk::Instance`] handle\n\n* []() VUID-vkDestroySurfaceKHR-surface-parameter  \n   If [`Self::surface`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkDestroySurfaceKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroySurfaceKHR-surface-parent  \n   If [`Self::surface`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::instance`]\n\nHost Synchronization\n\n* Host access to [`Self::surface`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Instance`], [`crate::vk::SurfaceKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkDestroySurfaceKHR = unsafe extern "system" fn(instance: crate::vk1_0::Instance, surface: crate::extensions::khr_surface::SurfaceKHR, p_allocator: *const crate::vk1_0::AllocationCallbacks) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceSupportKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceSupportKHR - Query if presentation is supported\n[](#_c_specification)C Specification\n----------\n\nTo determine whether a queue family of a physical device supports\npresentation to a given surface, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceSupportKHR(\n    VkPhysicalDevice                            physicalDevice,\n    uint32_t                                    queueFamilyIndex,\n    VkSurfaceKHR                                surface,\n    VkBool32*                                   pSupported);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device.\n\n* [`Self::queue_family_index`] is the queue family.\n\n* [`Self::surface`] is the surface.\n\n* [`Self::p_supported`] is a pointer to a [`crate::vk::Bool32`], which is set to[`crate::vk::TRUE`] to indicate support, and [`crate::vk::FALSE`] otherwise.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-queueFamilyIndex-01269  \n  [`Self::queue_family_index`] **must** be less than`pQueueFamilyPropertyCount` returned by[`crate::vk::PFN_vkGetPhysicalDeviceQueueFamilyProperties`] for the given[`Self::physical_device`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-pSupported-parameter  \n  [`Self::p_supported`] **must** be a valid pointer to a [`crate::vk::Bool32`] value\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceSurfaceSupportKHR = unsafe extern "system" fn(physical_device: crate::vk1_0::PhysicalDevice, queue_family_index: u32, surface: crate::extensions::khr_surface::SurfaceKHR, p_supported: *mut crate::vk1_0::Bool32) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceCapabilitiesKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceCapabilitiesKHR - Query surface capabilities\n[](#_c_specification)C Specification\n----------\n\nTo query the basic capabilities of a surface, needed in order to create a\nswapchain, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceCapabilitiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    VkSurfaceCapabilitiesKHR*                   pSurfaceCapabilities);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_surface_capabilities`] is a pointer to a[`crate::vk::SurfaceCapabilitiesKHR`] structure in which the capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-pSurfaceCapabilities-parameter  \n  [`Self::p_surface_capabilities`] **must** be a valid pointer to a [`crate::vk::SurfaceCapabilitiesKHR`] structure\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceCapabilitiesKHR`], [`crate::vk::SurfaceKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceSurfaceCapabilitiesKHR = unsafe extern "system" fn(physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR, p_surface_capabilities: *mut crate::extensions::khr_surface::SurfaceCapabilitiesKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceFormatsKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceFormatsKHR - Query color formats supported by surface\n[](#_c_specification)C Specification\n----------\n\nTo query the supported swapchain format-color space pairs for a surface,\ncall:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceFormatsKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    uint32_t*                                   pSurfaceFormatCount,\n    VkSurfaceFormatKHR*                         pSurfaceFormats);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_surface_format_count`] is a pointer to an integer related to the\n  number of format pairs available or queried, as described below.\n\n* [`Self::p_surface_formats`] is either `NULL` or a pointer to an array of[`crate::vk::SurfaceFormatKHR`] structures.\n[](#_description)Description\n----------\n\nIf [`Self::p_surface_formats`] is `NULL`, then the number of format pairs\nsupported for the given [`Self::surface`] is returned in[`Self::p_surface_format_count`].\nOtherwise, [`Self::p_surface_format_count`] **must** point to a variable set by the\nuser to the number of elements in the [`Self::p_surface_formats`] array, and on\nreturn the variable is overwritten with the number of structures actually\nwritten to [`Self::p_surface_formats`].\nIf the value of [`Self::p_surface_format_count`] is less than the number of format\npairs supported, at most [`Self::p_surface_format_count`] structures will be\nwritten, and [`crate::vk::Result::INCOMPLETE`] will be returned instead of[`crate::vk::Result::SUCCESS`], to indicate that not all the available format pairs were\nreturned.\n\nThe number of format pairs supported **must** be greater than or equal to 1.[`Self::p_surface_formats`] **must** not contain an entry whose value for`format` is [`crate::vk::Format::UNDEFINED`].\n\nIf [`Self::p_surface_formats`] includes an entry whose value for `colorSpace`is [`crate::vk::ColorSpaceKHR::SRGB_NONLINEAR_KHR`] and whose value for `format`is a UNORM (or SRGB) format and the corresponding SRGB (or UNORM) format is\na color renderable format for [`crate::vk::ImageTiling::OPTIMAL`], then[`Self::p_surface_formats`] **must** also contain an entry with the same value for`colorSpace` and `format` equal to the corresponding SRGB (or UNORM)\nformat.\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormatCount-parameter  \n  [`Self::p_surface_format_count`] **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormats-parameter  \n   If the value referenced by [`Self::p_surface_format_count`] is not `0`, and [`Self::p_surface_formats`] is not `NULL`, [`Self::p_surface_formats`] **must** be a valid pointer to an array of [`Self::p_surface_format_count`] [`crate::vk::SurfaceFormatKHR`] structures\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceFormatKHR`], [`crate::vk::SurfaceKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceSurfaceFormatsKHR = unsafe extern "system" fn(physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR, p_surface_format_count: *mut u32, p_surface_formats: *mut crate::extensions::khr_surface::SurfaceFormatKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfacePresentModesKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfacePresentModesKHR - Query supported presentation modes\n[](#_c_specification)C Specification\n----------\n\nTo query the supported presentation modes for a surface, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfacePresentModesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    uint32_t*                                   pPresentModeCount,\n    VkPresentModeKHR*                           pPresentModes);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_present_mode_count`] is a pointer to an integer related to the number\n  of presentation modes available or queried, as described below.\n\n* [`Self::p_present_modes`] is either `NULL` or a pointer to an array of[`crate::vk::PresentModeKHR`] values, indicating the supported presentation\n  modes.\n[](#_description)Description\n----------\n\nIf [`Self::p_present_modes`] is `NULL`, then the number of presentation modes\nsupported for the given [`Self::surface`] is returned in[`Self::p_present_mode_count`].\nOtherwise, [`Self::p_present_mode_count`] **must** point to a variable set by the user\nto the number of elements in the [`Self::p_present_modes`] array, and on return\nthe variable is overwritten with the number of values actually written to[`Self::p_present_modes`].\nIf the value of [`Self::p_present_mode_count`] is less than the number of\npresentation modes supported, at most [`Self::p_present_mode_count`] values will be\nwritten, and [`crate::vk::Result::INCOMPLETE`] will be returned instead of[`crate::vk::Result::SUCCESS`], to indicate that not all the available modes were\nreturned.\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModeCount-parameter  \n  [`Self::p_present_mode_count`] **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModes-parameter  \n   If the value referenced by [`Self::p_present_mode_count`] is not `0`, and [`Self::p_present_modes`] is not `NULL`, [`Self::p_present_modes`] **must** be a valid pointer to an array of [`Self::p_present_mode_count`] [`crate::vk::PresentModeKHR`] values\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::PresentModeKHR`], [`crate::vk::SurfaceKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceSurfacePresentModesKHR = unsafe extern "system" fn(physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR, p_present_mode_count: *mut u32, p_present_modes: *mut crate::extensions::khr_surface::PresentModeKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceCapabilitiesKHR.html)) · Structure <br/> VkSurfaceCapabilitiesKHR - Structure describing capabilities of a surface\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SurfaceCapabilitiesKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_surface\ntypedef struct VkSurfaceCapabilitiesKHR {\n    uint32_t                         minImageCount;\n    uint32_t                         maxImageCount;\n    VkExtent2D                       currentExtent;\n    VkExtent2D                       minImageExtent;\n    VkExtent2D                       maxImageExtent;\n    uint32_t                         maxImageArrayLayers;\n    VkSurfaceTransformFlagsKHR       supportedTransforms;\n    VkSurfaceTransformFlagBitsKHR    currentTransform;\n    VkCompositeAlphaFlagsKHR         supportedCompositeAlpha;\n    VkImageUsageFlags                supportedUsageFlags;\n} VkSurfaceCapabilitiesKHR;\n```\n[](#_members)Members\n----------\n[](#_description)Description\n----------\n\n* [`Self::min_image_count`] is the minimum number of images the specified device\n  supports for a swapchain created for the surface, and will be at least\n  one.\n\n* [`Self::max_image_count`] is the maximum number of images the specified device\n  supports for a swapchain created for the surface, and will be either 0,\n  or greater than or equal to [`Self::min_image_count`].\n  A value of 0 means that there is no limit on the number of images,\n  though there **may** be limits related to the total amount of memory used\n  by presentable images.\n\n* [`Self::current_extent`] is the current width and height of the surface, or\n  the special value (0xFFFFFFFF, 0xFFFFFFFF) indicating that the\n  surface size will be determined by the extent of a swapchain targeting\n  the surface.\n\n* [`Self::min_image_extent`] contains the smallest valid swapchain extent for\n  the surface on the specified device.\n  The `width` and `height` of the extent will each be less than or\n  equal to the corresponding `width` and `height` of[`Self::current_extent`], unless [`Self::current_extent`] has the special value\n  described above.\n\n* [`Self::max_image_extent`] contains the largest valid swapchain extent for the\n  surface on the specified device.\n  The `width` and `height` of the extent will each be greater than\n  or equal to the corresponding `width` and `height` of[`Self::min_image_extent`].\n  The `width` and `height` of the extent will each be greater than\n  or equal to the corresponding `width` and `height` of[`Self::current_extent`], unless [`Self::current_extent`] has the special value\n  described above.\n\n* [`Self::max_image_array_layers`] is the maximum number of layers presentable\n  images **can** have for a swapchain created for this device and surface,\n  and will be at least one.\n\n* [`Self::supported_transforms`] is a bitmask of[VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html) indicating the presentation\n  transforms supported for the surface on the specified device.\n  At least one bit will be set.\n\n* [`Self::current_transform`] is [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html) value\n  indicating the surface’s current transform relative to the presentation\n  engine’s natural orientation.\n\n* [`Self::supported_composite_alpha`] is a bitmask of[VkCompositeAlphaFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html), representing the alpha compositing\n  modes supported by the presentation engine for the surface on the\n  specified device, and at least one bit will be set.\n  Opaque composition **can** be achieved in any alpha compositing mode by\n  either using an image format that has no alpha component, or by ensuring\n  that all pixels in the presentable images have an alpha value of 1.0.\n\n* [`Self::supported_usage_flags`] is a bitmask of [VkImageUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageUsageFlagBits.html)representing the ways the application **can** use the presentable images of\n  a swapchain created\n  with [`crate::vk::PresentModeKHR`] set to [`crate::vk::PresentModeKHR::IMMEDIATE_KHR`],[`crate::vk::PresentModeKHR::MAILBOX_KHR`], [`crate::vk::PresentModeKHR::FIFO_KHR`] or[`crate::vk::PresentModeKHR::FIFO_RELAXED_KHR`]for the surface on the specified device.[`crate::vk::ImageUsageFlagBits::COLOR_ATTACHMENT`] **must** be included in the set.\n  Implementations **may** support additional usages.\n\n|   |Note<br/><br/>Supported usage flags of a presentable image when using[`crate::vk::PresentModeKHR::SHARED_DEMAND_REFRESH_KHR`] or[`crate::vk::PresentModeKHR::SHARED_CONTINUOUS_REFRESH_KHR`] presentation mode are<br/>provided by[`crate::vk::SharedPresentSurfaceCapabilitiesKHR::shared_present_supported_usage_flags`].|\n|---|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>Formulas such as min(N, [`Self::max_image_count`]) are not correct, since[`Self::max_image_count`] **may** be zero.|\n|---|-------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CompositeAlphaFlagBitsKHR`], [`crate::vk::Extent2D`], [`crate::vk::ImageUsageFlagBits`], [`crate::vk::SurfaceCapabilities2KHR`], [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html), [`crate::vk::SurfaceTransformFlagBitsKHR`], [`crate::vk::InstanceLoader::get_physical_device_surface_capabilities_khr`]\n"]
#[doc(alias = "VkSurfaceCapabilitiesKHR")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct SurfaceCapabilitiesKHR {
    pub min_image_count: u32,
    pub max_image_count: u32,
    pub current_extent: crate::vk1_0::Extent2D,
    pub min_image_extent: crate::vk1_0::Extent2D,
    pub max_image_extent: crate::vk1_0::Extent2D,
    pub max_image_array_layers: u32,
    pub supported_transforms: crate::extensions::khr_surface::SurfaceTransformFlagsKHR,
    pub current_transform: crate::extensions::khr_surface::SurfaceTransformFlagBitsKHR,
    pub supported_composite_alpha: crate::extensions::khr_surface::CompositeAlphaFlagsKHR,
    pub supported_usage_flags: crate::vk1_0::ImageUsageFlags,
}
impl Default for SurfaceCapabilitiesKHR {
    fn default() -> Self {
        Self { min_image_count: Default::default(), max_image_count: Default::default(), current_extent: Default::default(), min_image_extent: Default::default(), max_image_extent: Default::default(), max_image_array_layers: Default::default(), supported_transforms: Default::default(), current_transform: Default::default(), supported_composite_alpha: Default::default(), supported_usage_flags: Default::default() }
    }
}
impl std::fmt::Debug for SurfaceCapabilitiesKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("SurfaceCapabilitiesKHR").field("min_image_count", &self.min_image_count).field("max_image_count", &self.max_image_count).field("current_extent", &self.current_extent).field("min_image_extent", &self.min_image_extent).field("max_image_extent", &self.max_image_extent).field("max_image_array_layers", &self.max_image_array_layers).field("supported_transforms", &self.supported_transforms).field("current_transform", &self.current_transform).field("supported_composite_alpha", &self.supported_composite_alpha).field("supported_usage_flags", &self.supported_usage_flags).finish()
    }
}
impl SurfaceCapabilitiesKHR {
    #[inline]
    pub fn into_builder<'a>(self) -> SurfaceCapabilitiesKHRBuilder<'a> {
        SurfaceCapabilitiesKHRBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceCapabilitiesKHR.html)) · Builder of [`SurfaceCapabilitiesKHR`] <br/> VkSurfaceCapabilitiesKHR - Structure describing capabilities of a surface\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SurfaceCapabilitiesKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_surface\ntypedef struct VkSurfaceCapabilitiesKHR {\n    uint32_t                         minImageCount;\n    uint32_t                         maxImageCount;\n    VkExtent2D                       currentExtent;\n    VkExtent2D                       minImageExtent;\n    VkExtent2D                       maxImageExtent;\n    uint32_t                         maxImageArrayLayers;\n    VkSurfaceTransformFlagsKHR       supportedTransforms;\n    VkSurfaceTransformFlagBitsKHR    currentTransform;\n    VkCompositeAlphaFlagsKHR         supportedCompositeAlpha;\n    VkImageUsageFlags                supportedUsageFlags;\n} VkSurfaceCapabilitiesKHR;\n```\n[](#_members)Members\n----------\n[](#_description)Description\n----------\n\n* [`Self::min_image_count`] is the minimum number of images the specified device\n  supports for a swapchain created for the surface, and will be at least\n  one.\n\n* [`Self::max_image_count`] is the maximum number of images the specified device\n  supports for a swapchain created for the surface, and will be either 0,\n  or greater than or equal to [`Self::min_image_count`].\n  A value of 0 means that there is no limit on the number of images,\n  though there **may** be limits related to the total amount of memory used\n  by presentable images.\n\n* [`Self::current_extent`] is the current width and height of the surface, or\n  the special value (0xFFFFFFFF, 0xFFFFFFFF) indicating that the\n  surface size will be determined by the extent of a swapchain targeting\n  the surface.\n\n* [`Self::min_image_extent`] contains the smallest valid swapchain extent for\n  the surface on the specified device.\n  The `width` and `height` of the extent will each be less than or\n  equal to the corresponding `width` and `height` of[`Self::current_extent`], unless [`Self::current_extent`] has the special value\n  described above.\n\n* [`Self::max_image_extent`] contains the largest valid swapchain extent for the\n  surface on the specified device.\n  The `width` and `height` of the extent will each be greater than\n  or equal to the corresponding `width` and `height` of[`Self::min_image_extent`].\n  The `width` and `height` of the extent will each be greater than\n  or equal to the corresponding `width` and `height` of[`Self::current_extent`], unless [`Self::current_extent`] has the special value\n  described above.\n\n* [`Self::max_image_array_layers`] is the maximum number of layers presentable\n  images **can** have for a swapchain created for this device and surface,\n  and will be at least one.\n\n* [`Self::supported_transforms`] is a bitmask of[VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html) indicating the presentation\n  transforms supported for the surface on the specified device.\n  At least one bit will be set.\n\n* [`Self::current_transform`] is [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html) value\n  indicating the surface’s current transform relative to the presentation\n  engine’s natural orientation.\n\n* [`Self::supported_composite_alpha`] is a bitmask of[VkCompositeAlphaFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkCompositeAlphaFlagBitsKHR.html), representing the alpha compositing\n  modes supported by the presentation engine for the surface on the\n  specified device, and at least one bit will be set.\n  Opaque composition **can** be achieved in any alpha compositing mode by\n  either using an image format that has no alpha component, or by ensuring\n  that all pixels in the presentable images have an alpha value of 1.0.\n\n* [`Self::supported_usage_flags`] is a bitmask of [VkImageUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageUsageFlagBits.html)representing the ways the application **can** use the presentable images of\n  a swapchain created\n  with [`crate::vk::PresentModeKHR`] set to [`crate::vk::PresentModeKHR::IMMEDIATE_KHR`],[`crate::vk::PresentModeKHR::MAILBOX_KHR`], [`crate::vk::PresentModeKHR::FIFO_KHR`] or[`crate::vk::PresentModeKHR::FIFO_RELAXED_KHR`]for the surface on the specified device.[`crate::vk::ImageUsageFlagBits::COLOR_ATTACHMENT`] **must** be included in the set.\n  Implementations **may** support additional usages.\n\n|   |Note<br/><br/>Supported usage flags of a presentable image when using[`crate::vk::PresentModeKHR::SHARED_DEMAND_REFRESH_KHR`] or[`crate::vk::PresentModeKHR::SHARED_CONTINUOUS_REFRESH_KHR`] presentation mode are<br/>provided by[`crate::vk::SharedPresentSurfaceCapabilitiesKHR::shared_present_supported_usage_flags`].|\n|---|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>Formulas such as min(N, [`Self::max_image_count`]) are not correct, since[`Self::max_image_count`] **may** be zero.|\n|---|-------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CompositeAlphaFlagBitsKHR`], [`crate::vk::Extent2D`], [`crate::vk::ImageUsageFlagBits`], [`crate::vk::SurfaceCapabilities2KHR`], [VkSurfaceTransformFlagBitsKHR](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceTransformFlagBitsKHR.html), [`crate::vk::SurfaceTransformFlagBitsKHR`], [`crate::vk::InstanceLoader::get_physical_device_surface_capabilities_khr`]\n"]
#[repr(transparent)]
pub struct SurfaceCapabilitiesKHRBuilder<'a>(SurfaceCapabilitiesKHR, std::marker::PhantomData<&'a ()>);
impl<'a> SurfaceCapabilitiesKHRBuilder<'a> {
    #[inline]
    pub fn new() -> SurfaceCapabilitiesKHRBuilder<'a> {
        SurfaceCapabilitiesKHRBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn min_image_count(mut self, min_image_count: u32) -> Self {
        self.0.min_image_count = min_image_count as _;
        self
    }
    #[inline]
    pub fn max_image_count(mut self, max_image_count: u32) -> Self {
        self.0.max_image_count = max_image_count as _;
        self
    }
    #[inline]
    pub fn current_extent(mut self, current_extent: crate::vk1_0::Extent2D) -> Self {
        self.0.current_extent = current_extent as _;
        self
    }
    #[inline]
    pub fn min_image_extent(mut self, min_image_extent: crate::vk1_0::Extent2D) -> Self {
        self.0.min_image_extent = min_image_extent as _;
        self
    }
    #[inline]
    pub fn max_image_extent(mut self, max_image_extent: crate::vk1_0::Extent2D) -> Self {
        self.0.max_image_extent = max_image_extent as _;
        self
    }
    #[inline]
    pub fn max_image_array_layers(mut self, max_image_array_layers: u32) -> Self {
        self.0.max_image_array_layers = max_image_array_layers as _;
        self
    }
    #[inline]
    pub fn supported_transforms(mut self, supported_transforms: crate::extensions::khr_surface::SurfaceTransformFlagsKHR) -> Self {
        self.0.supported_transforms = supported_transforms as _;
        self
    }
    #[inline]
    pub fn current_transform(mut self, current_transform: crate::extensions::khr_surface::SurfaceTransformFlagBitsKHR) -> Self {
        self.0.current_transform = current_transform as _;
        self
    }
    #[inline]
    pub fn supported_composite_alpha(mut self, supported_composite_alpha: crate::extensions::khr_surface::CompositeAlphaFlagsKHR) -> Self {
        self.0.supported_composite_alpha = supported_composite_alpha as _;
        self
    }
    #[inline]
    pub fn supported_usage_flags(mut self, supported_usage_flags: crate::vk1_0::ImageUsageFlags) -> Self {
        self.0.supported_usage_flags = supported_usage_flags as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> SurfaceCapabilitiesKHR {
        self.0
    }
}
impl<'a> std::default::Default for SurfaceCapabilitiesKHRBuilder<'a> {
    fn default() -> SurfaceCapabilitiesKHRBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for SurfaceCapabilitiesKHRBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for SurfaceCapabilitiesKHRBuilder<'a> {
    type Target = SurfaceCapabilitiesKHR;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for SurfaceCapabilitiesKHRBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceFormatKHR.html)) · Structure <br/> VkSurfaceFormatKHR - Structure describing a supported swapchain format-color space pair\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SurfaceFormatKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_surface\ntypedef struct VkSurfaceFormatKHR {\n    VkFormat           format;\n    VkColorSpaceKHR    colorSpace;\n} VkSurfaceFormatKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::format`] is a [`crate::vk::Format`] that is compatible with the specified\n  surface.\n\n* [`Self::color_space`] is a presentation [`crate::vk::ColorSpaceKHR`] that is\n  compatible with the surface.\n[](#_description)Description\n----------\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ColorSpaceKHR`], [`crate::vk::Format`], [`crate::vk::SurfaceFormat2KHR`], [`crate::vk::InstanceLoader::get_physical_device_surface_formats_khr`]\n"]
#[doc(alias = "VkSurfaceFormatKHR")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct SurfaceFormatKHR {
    pub format: crate::vk1_0::Format,
    pub color_space: crate::extensions::khr_surface::ColorSpaceKHR,
}
impl Default for SurfaceFormatKHR {
    fn default() -> Self {
        Self { format: Default::default(), color_space: Default::default() }
    }
}
impl std::fmt::Debug for SurfaceFormatKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("SurfaceFormatKHR").field("format", &self.format).field("color_space", &self.color_space).finish()
    }
}
impl SurfaceFormatKHR {
    #[inline]
    pub fn into_builder<'a>(self) -> SurfaceFormatKHRBuilder<'a> {
        SurfaceFormatKHRBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSurfaceFormatKHR.html)) · Builder of [`SurfaceFormatKHR`] <br/> VkSurfaceFormatKHR - Structure describing a supported swapchain format-color space pair\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SurfaceFormatKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_surface\ntypedef struct VkSurfaceFormatKHR {\n    VkFormat           format;\n    VkColorSpaceKHR    colorSpace;\n} VkSurfaceFormatKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::format`] is a [`crate::vk::Format`] that is compatible with the specified\n  surface.\n\n* [`Self::color_space`] is a presentation [`crate::vk::ColorSpaceKHR`] that is\n  compatible with the surface.\n[](#_description)Description\n----------\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ColorSpaceKHR`], [`crate::vk::Format`], [`crate::vk::SurfaceFormat2KHR`], [`crate::vk::InstanceLoader::get_physical_device_surface_formats_khr`]\n"]
#[repr(transparent)]
pub struct SurfaceFormatKHRBuilder<'a>(SurfaceFormatKHR, std::marker::PhantomData<&'a ()>);
impl<'a> SurfaceFormatKHRBuilder<'a> {
    #[inline]
    pub fn new() -> SurfaceFormatKHRBuilder<'a> {
        SurfaceFormatKHRBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn format(mut self, format: crate::vk1_0::Format) -> Self {
        self.0.format = format as _;
        self
    }
    #[inline]
    pub fn color_space(mut self, color_space: crate::extensions::khr_surface::ColorSpaceKHR) -> Self {
        self.0.color_space = color_space as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> SurfaceFormatKHR {
        self.0
    }
}
impl<'a> std::default::Default for SurfaceFormatKHRBuilder<'a> {
    fn default() -> SurfaceFormatKHRBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for SurfaceFormatKHRBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for SurfaceFormatKHRBuilder<'a> {
    type Target = SurfaceFormatKHR;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for SurfaceFormatKHRBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::khr_surface`]"]
impl crate::InstanceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroySurfaceKHR.html)) · Function <br/> vkDestroySurfaceKHR - Destroy a VkSurfaceKHR object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a [`crate::vk::SurfaceKHR`] object, call:\n\n```\n// Provided by VK_KHR_surface\nvoid vkDestroySurfaceKHR(\n    VkInstance                                  instance,\n    VkSurfaceKHR                                surface,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::instance`] is the instance used to create the surface.\n\n* [`Self::surface`] is the surface to destroy.\n\n* [`Self::p_allocator`] is the allocator used for host memory allocated for the\n  surface object when there is no more specific allocator available (see[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation)).\n[](#_description)Description\n----------\n\nDestroying a [`crate::vk::SurfaceKHR`] merely severs the connection between Vulkan\nand the native surface, and does not imply destroying the native surface,\nclosing a window, or similar behavior.\n\nValid Usage\n\n* []() VUID-vkDestroySurfaceKHR-surface-01266  \n   All [`crate::vk::SwapchainKHR`] objects created for [`Self::surface`] **must** have\n  been destroyed prior to destroying [`Self::surface`]\n\n* []() VUID-vkDestroySurfaceKHR-surface-01267  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::surface`] was\n  created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroySurfaceKHR-surface-01268  \n   If no [`crate::vk::AllocationCallbacks`] were provided when [`Self::surface`] was\n  created, [`Self::p_allocator`] **must** be `NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroySurfaceKHR-instance-parameter  \n  [`Self::instance`] **must** be a valid [`crate::vk::Instance`] handle\n\n* []() VUID-vkDestroySurfaceKHR-surface-parameter  \n   If [`Self::surface`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkDestroySurfaceKHR-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroySurfaceKHR-surface-parent  \n   If [`Self::surface`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::instance`]\n\nHost Synchronization\n\n* Host access to [`Self::surface`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Instance`], [`crate::vk::SurfaceKHR`]\n"]
    #[doc(alias = "vkDestroySurfaceKHR")]
    pub unsafe fn destroy_surface_khr(&self, surface: Option<crate::extensions::khr_surface::SurfaceKHR>, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> () {
        let _function = self.destroy_surface_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(
            self.handle,
            match surface {
                Some(v) => v,
                None => Default::default(),
            },
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
        );
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceSupportKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceSupportKHR - Query if presentation is supported\n[](#_c_specification)C Specification\n----------\n\nTo determine whether a queue family of a physical device supports\npresentation to a given surface, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceSupportKHR(\n    VkPhysicalDevice                            physicalDevice,\n    uint32_t                                    queueFamilyIndex,\n    VkSurfaceKHR                                surface,\n    VkBool32*                                   pSupported);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device.\n\n* [`Self::queue_family_index`] is the queue family.\n\n* [`Self::surface`] is the surface.\n\n* [`Self::p_supported`] is a pointer to a [`crate::vk::Bool32`], which is set to[`crate::vk::TRUE`] to indicate support, and [`crate::vk::FALSE`] otherwise.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-queueFamilyIndex-01269  \n  [`Self::queue_family_index`] **must** be less than`pQueueFamilyPropertyCount` returned by[`crate::vk::PFN_vkGetPhysicalDeviceQueueFamilyProperties`] for the given[`Self::physical_device`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-pSupported-parameter  \n  [`Self::p_supported`] **must** be a valid pointer to a [`crate::vk::Bool32`] value\n\n* []() VUID-vkGetPhysicalDeviceSurfaceSupportKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceKHR`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceSurfaceSupportKHR")]
    pub unsafe fn get_physical_device_surface_support_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, queue_family_index: u32, surface: crate::extensions::khr_surface::SurfaceKHR) -> crate::utils::VulkanResult<bool> {
        let _function = self.get_physical_device_surface_support_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut supported = Default::default();
        let _return = _function(physical_device as _, queue_family_index as _, surface as _, &mut supported);
        crate::utils::VulkanResult::new(_return, supported != 0)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceCapabilitiesKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceCapabilitiesKHR - Query surface capabilities\n[](#_c_specification)C Specification\n----------\n\nTo query the basic capabilities of a surface, needed in order to create a\nswapchain, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceCapabilitiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    VkSurfaceCapabilitiesKHR*                   pSurfaceCapabilities);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_surface_capabilities`] is a pointer to a[`crate::vk::SurfaceCapabilitiesKHR`] structure in which the capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-pSurfaceCapabilities-parameter  \n  [`Self::p_surface_capabilities`] **must** be a valid pointer to a [`crate::vk::SurfaceCapabilitiesKHR`] structure\n\n* []() VUID-vkGetPhysicalDeviceSurfaceCapabilitiesKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceCapabilitiesKHR`], [`crate::vk::SurfaceKHR`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceSurfaceCapabilitiesKHR")]
    pub unsafe fn get_physical_device_surface_capabilities_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR) -> crate::utils::VulkanResult<crate::extensions::khr_surface::SurfaceCapabilitiesKHR> {
        let _function = self.get_physical_device_surface_capabilities_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut surface_capabilities = Default::default();
        let _return = _function(physical_device as _, surface as _, &mut surface_capabilities);
        crate::utils::VulkanResult::new(_return, surface_capabilities)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfaceFormatsKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfaceFormatsKHR - Query color formats supported by surface\n[](#_c_specification)C Specification\n----------\n\nTo query the supported swapchain format-color space pairs for a surface,\ncall:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfaceFormatsKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    uint32_t*                                   pSurfaceFormatCount,\n    VkSurfaceFormatKHR*                         pSurfaceFormats);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_surface_format_count`] is a pointer to an integer related to the\n  number of format pairs available or queried, as described below.\n\n* [`Self::p_surface_formats`] is either `NULL` or a pointer to an array of[`crate::vk::SurfaceFormatKHR`] structures.\n[](#_description)Description\n----------\n\nIf [`Self::p_surface_formats`] is `NULL`, then the number of format pairs\nsupported for the given [`Self::surface`] is returned in[`Self::p_surface_format_count`].\nOtherwise, [`Self::p_surface_format_count`] **must** point to a variable set by the\nuser to the number of elements in the [`Self::p_surface_formats`] array, and on\nreturn the variable is overwritten with the number of structures actually\nwritten to [`Self::p_surface_formats`].\nIf the value of [`Self::p_surface_format_count`] is less than the number of format\npairs supported, at most [`Self::p_surface_format_count`] structures will be\nwritten, and [`crate::vk::Result::INCOMPLETE`] will be returned instead of[`crate::vk::Result::SUCCESS`], to indicate that not all the available format pairs were\nreturned.\n\nThe number of format pairs supported **must** be greater than or equal to 1.[`Self::p_surface_formats`] **must** not contain an entry whose value for`format` is [`crate::vk::Format::UNDEFINED`].\n\nIf [`Self::p_surface_formats`] includes an entry whose value for `colorSpace`is [`crate::vk::ColorSpaceKHR::SRGB_NONLINEAR_KHR`] and whose value for `format`is a UNORM (or SRGB) format and the corresponding SRGB (or UNORM) format is\na color renderable format for [`crate::vk::ImageTiling::OPTIMAL`], then[`Self::p_surface_formats`] **must** also contain an entry with the same value for`colorSpace` and `format` equal to the corresponding SRGB (or UNORM)\nformat.\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormatCount-parameter  \n  [`Self::p_surface_format_count`] **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-pSurfaceFormats-parameter  \n   If the value referenced by [`Self::p_surface_format_count`] is not `0`, and [`Self::p_surface_formats`] is not `NULL`, [`Self::p_surface_formats`] **must** be a valid pointer to an array of [`Self::p_surface_format_count`] [`crate::vk::SurfaceFormatKHR`] structures\n\n* []() VUID-vkGetPhysicalDeviceSurfaceFormatsKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::SurfaceFormatKHR`], [`crate::vk::SurfaceKHR`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceSurfaceFormatsKHR")]
    pub unsafe fn get_physical_device_surface_formats_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR, surface_format_count: Option<u32>) -> crate::utils::VulkanResult<crate::SmallVec<crate::extensions::khr_surface::SurfaceFormatKHR>> {
        let _function = self.get_physical_device_surface_formats_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut surface_format_count = match surface_format_count {
            Some(v) => v,
            None => {
                let mut v = Default::default();
                _function(physical_device as _, surface as _, &mut v, std::ptr::null_mut());
                v
            }
        };
        let mut surface_formats = crate::SmallVec::from_elem(Default::default(), surface_format_count as _);
        let _return = _function(physical_device as _, surface as _, &mut surface_format_count, surface_formats.as_mut_ptr());
        crate::utils::VulkanResult::new(_return, surface_formats)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceSurfacePresentModesKHR.html)) · Function <br/> vkGetPhysicalDeviceSurfacePresentModesKHR - Query supported presentation modes\n[](#_c_specification)C Specification\n----------\n\nTo query the supported presentation modes for a surface, call:\n\n```\n// Provided by VK_KHR_surface\nVkResult vkGetPhysicalDeviceSurfacePresentModesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    VkSurfaceKHR                                surface,\n    uint32_t*                                   pPresentModeCount,\n    VkPresentModeKHR*                           pPresentModes);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::physical_device`] is the physical device that will be associated with\n  the swapchain to be created, as described for[`crate::vk::DeviceLoader::create_swapchain_khr`].\n\n* [`Self::surface`] is the surface that will be associated with the swapchain.\n\n* [`Self::p_present_mode_count`] is a pointer to an integer related to the number\n  of presentation modes available or queried, as described below.\n\n* [`Self::p_present_modes`] is either `NULL` or a pointer to an array of[`crate::vk::PresentModeKHR`] values, indicating the supported presentation\n  modes.\n[](#_description)Description\n----------\n\nIf [`Self::p_present_modes`] is `NULL`, then the number of presentation modes\nsupported for the given [`Self::surface`] is returned in[`Self::p_present_mode_count`].\nOtherwise, [`Self::p_present_mode_count`] **must** point to a variable set by the user\nto the number of elements in the [`Self::p_present_modes`] array, and on return\nthe variable is overwritten with the number of values actually written to[`Self::p_present_modes`].\nIf the value of [`Self::p_present_mode_count`] is less than the number of\npresentation modes supported, at most [`Self::p_present_mode_count`] values will be\nwritten, and [`crate::vk::Result::INCOMPLETE`] will be returned instead of[`crate::vk::Result::SUCCESS`], to indicate that not all the available modes were\nreturned.\n\nValid Usage\n\n* [[VUID-{refpage}-surface-06211]] VUID-{refpage}-surface-06211  \n  [`Self::surface`] **must** be supported by [`Self::physical_device`], as reported by[`crate::vk::InstanceLoader::get_physical_device_surface_support_khr`] or an equivalent\n  platform-specific mechanism\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-physicalDevice-parameter  \n  [`Self::physical_device`] **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-surface-parameter  \n  [`Self::surface`] **must** be a valid [`crate::vk::SurfaceKHR`] handle\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModeCount-parameter  \n  [`Self::p_present_mode_count`] **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-pPresentModes-parameter  \n   If the value referenced by [`Self::p_present_mode_count`] is not `0`, and [`Self::p_present_modes`] is not `NULL`, [`Self::p_present_modes`] **must** be a valid pointer to an array of [`Self::p_present_mode_count`] [`crate::vk::PresentModeKHR`] values\n\n* []() VUID-vkGetPhysicalDeviceSurfacePresentModesKHR-commonparent  \n   Both of [`Self::physical_device`], and [`Self::surface`] **must** have been created, allocated, or retrieved from the same [`crate::vk::Instance`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n\n* [`crate::vk::Result::ERROR_SURFACE_LOST_KHR`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDevice`], [`crate::vk::PresentModeKHR`], [`crate::vk::SurfaceKHR`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceSurfacePresentModesKHR")]
    pub unsafe fn get_physical_device_surface_present_modes_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, surface: crate::extensions::khr_surface::SurfaceKHR, present_mode_count: Option<u32>) -> crate::utils::VulkanResult<crate::SmallVec<crate::extensions::khr_surface::PresentModeKHR>> {
        let _function = self.get_physical_device_surface_present_modes_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut present_mode_count = match present_mode_count {
            Some(v) => v,
            None => {
                let mut v = Default::default();
                _function(physical_device as _, surface as _, &mut v, std::ptr::null_mut());
                v
            }
        };
        let mut present_modes = crate::SmallVec::from_elem(Default::default(), present_mode_count as _);
        let _return = _function(physical_device as _, surface as _, &mut present_mode_count, present_modes.as_mut_ptr());
        crate::utils::VulkanResult::new(_return, present_modes)
    }
}
